#ifndef EFL_GENERATED_EVAS_RECTANGLE_HH
#define EFL_GENERATED_EVAS_RECTANGLE_HH

#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "evas_rectangle.eo.h"
}

#include "evas_object.eo.hh"

namespace evas { 

struct rectangle
      : evas::object
{
   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit rectangle(Eo* eo)
      : evas::object(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit rectangle(std::nullptr_t)
      : evas::object(nullptr)
   {}

   rectangle(efl::eo::parent_type _p = (efl::eo::parent = nullptr))
      : rectangle(_c0(_p))
   {}

   /// @brief Copy Constructor.
   ///
   rectangle(rectangle const& other)
      : evas::object(eo_ref(other._eo_ptr()))
   {}

   ~rectangle() {}

   static Eo_Class const* _eo_class()
   {
      return(EVAS_RECTANGLE_CLASS);
   }

private:
   static Eo* _c0(efl::eo::parent_type _p)
   {
      return eo_add_custom(EVAS_RECTANGLE_CLASS, _p._eo_raw, eo_constructor());
   }

};
} 

namespace efl { namespace eo { namespace detail {

template<>
struct operations< evas::rectangle >
{
   template <typename T>
   struct type
   {
   };
};


template<>
struct operation_description_class_size< evas::rectangle >
{
   static const int value = 0;
};

template <typename T>
int initialize_operation_description(efl::eo::detail::tag<evas::rectangle>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   return 0;
}
inline void
call_constructor(tag< evas::rectangle >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<evas::rectangle, ::std::tuple<> > const& args)
{
   (void)args;
   eo_do_super(eo, cls, ::eo_constructor());
}

inline void
call_constructor(tag< evas::rectangle >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               args_class<evas::rectangle, ::std::tuple<efl::eo::parent_type> > const& args)
{
   eo_do_super(eo, cls, ::eo_constructor());
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

template<>
struct extension_inheritance< evas::rectangle>
{
   template <typename U>
   struct type
   {
      operator evas::rectangle() const
      {
         return evas::rectangle(eo_ref(static_cast<U const*>(this)->_eo_ptr()));
      }

   };
};

inline Eo_Class const* get_eo_class(tag<evas::rectangle>)
{
   return (EVAS_RECTANGLE_CLASS);
}

} } }
#endif // EFL_GENERATED_EVAS_RECTANGLE_HH

